# Devel Wizard

@todo


## How to add icon to the toolbar

Devel wizard module adds a new menu item to the admin toolbar.
By default it has no icon, while the others (Structure, Appearance, Extend ...)
do have icons.


### How to add icon to the toolbar - Step 1

```yaml
# File name: <MY_THEME>.info.yml
libraries-extend:
  toolbar/toolbar:
    - '<MY_THEME>/toolbar.toolbar'
```


### How to add icon to the toolbar - Step 2

```yaml
# File name: <MY_THEME>.libraries.yml
toolbar.toolbar:
  css:
    theme:
      /modules/contrib/devel_wizard/css/toolbar.icon.theme.css: {}
```


## Code


### API – Review page

After gathering the spell configuration and before doing anything
there should be a "review page" to provide a information about what is gonna happen.


### Assign colors to spell categories and tags

@todo


## Spell

New spell ideas or remaining tasks with existing spells.


### Spell – Render element – input false

* todo


### Spell – Render element – input true

* todo


### Spell – EventSubscriber

1. [x] Class
2. [x] Service



### Spell – Page

1. [x] Controller
2. [ ] Permission - new or existing
3. [x] Route
4. [x] Menu link


### Spell – Annotated Command validator attribute

**See**:
* `\Drupal\marvin\Attributes\ValidateArrayLength`
* `\Drush\Commands\marvin\MarvinCommands::onHookValidateMarvinArrayLength`

1. [ ] Attribute class.
2. [ ] Add a new handler method to the (existing or new) handler class.


### Spell – DevelWizard Spell

Generates a DevelWizard Spell plugin.

1. [ ] <module>/src/Plugin/DevelWizard/Spell/MySpell
2. [ ] <module>/src/Commands/MySpellCommands
3. [ ] <module>/drush.services.yml#/<module>.devel_wizard.spell.my_spell_id.commands
4. [ ] generate tests
5. [ ] write tests to check that if the spell works correctly


### Spell – Constraint (TypedData validator)

1. [ ] Basic implementation
2. [ ] generate tests
3. [ ] write tests to check that if the spell works correctly


### Spell – Image styles with responsive settings

Generated image styles and responsive definitions.

1. [ ] Basic implementation
2. [ ] generate tests
3. [ ] write tests to check that if the spell works correctly


### Spell – Workflow

Generates a workflow with states and transitions

1. [ ] Basic implementation
2. [ ] generate tests
3. [ ] write tests to check that if the spell works correctly


### Spell – Theme based on Claro

Tasks:
* [x] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Theme based on Olivero

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Library extend

Adds a new CSS/JS file to an existing library.

Tasks:
* [x] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Entity type

Tasks:
* [x] Config + Content - code
* [ ] Config + Content - test
* [x] Individual Config - code
* [ ] Individual Config - test
* [x] Individual Content - code
* [ ] Individual Content - test
* [ ] Config List builder ::status


### Spell – Entity bundle class

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Testimonial

Links:

* [Schema.org Review](https://schema.org/Review)
* [Schema.org CriticReview](https://schema.org/CriticReview)
* [Schema.org UserReview](https://schema.org/UserReview)
* [Schema.org Recommendation](https://schema.org/Recommendation)

Configuration:
* entityTypeId (bundleable content entity, eg:. node, block, paragraph)
* bundleId (default: testimonial)
* fields - Research Schema.org
* fields - first glance
  * Profile picture / Company logo
  * Name / Company name
  * Position (beosztás)
  * Body

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – News

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Event

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – BatchHandler

Tasks:
* [x] Class
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – advanced_queue plugin

Tasks:
* [ ] Plugin
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Group module

Tasks:
* [ ] OgPermissionEventSubscriber
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Project Behat configuration

Add basic Behat configuration to a Drupal project.

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Project PHPStan configuration

Add basic PHPStan configuration to a Drupal project.

Tasks:
* [ ] Basic implementation
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Set the whole mail system up

* [ ] Install, enable drupal/smtp
* [ ] HTML mails
* [ ]
* [ ] Generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – hook_mail()

@todo


### Spell – DrushCommands - data fetcher

@todo


### Spell – DrushCommands - action

@todo


### Spell – FieldFormatter

Tasks:
* [ ] fieldType date
* [ ] fieldType string
* [ ] fieldType number


### Spell – Access checker for routes

Service with tag: name, applies_to

Tasks:
* [x] Class implements \Drupal\Core\Routing\Access\AccessInterface
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Service decorator

Tasks:
* [ ] service definition + class with public methods
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – ParamConverter routes

Tasks:
* [x] basic Class + service definition
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – hook_token_info() and hook_tokens()

Tasks:
* [x] Basic implementation hook_token_info() and hook_tokens()
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Config object

Tasks:
* [x] config/schema/*.schema.yml
* [x] config/install/*.yml
* [x] src/ConfigObject/*Form.php
* [x] *.permissions.yml
* [x] *.routing.yml
* [x] *.links.menu.yml
* [x] *.info.yml#/configure
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – Plugin manager

https://www.drupal.org/docs/drupal-apis/plugin-api/creating-your-own-plugin-manager

Tasks:
* [x] Basic implementation
* [ ] Configurable discovery mechanisms
* [ ] generate tests
* [ ] write tests to check that if the spell works correctly


### Spell – devel_wizard_entity_type

Tasks:
* [x] Basic implementation
* [x] EntityType group support (individual spell)
* [ ] EntityType custom access API
* [ ] Field indexes
  * https://www.drupal.org/project/commerce/issues/2907367
  * https://www.drupal.org/files/issues/2020-10-07/2907367_0.patch
