<?php

declare(strict_types=1);

namespace Drupal\devel_wizard\Controller;

use Drupal\Core\Extension\ModuleExtensionList;
use Symfony\Component\DependencyInjection\ContainerInterface;

class AutocompleteModuleController extends AutocompleteExtensionController {

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('extension.list.module'),
    );
  }

  public function __construct(
    protected ModuleExtensionList $moduleList
  ) {
  }

  protected function getExtensions(): iterable {
    return $this->moduleList->getList();
  }

}
