<?php

declare(strict_types=1);

namespace Drupal\devel_wizard\Controller;

use Drupal\Core\Extension\ProfileExtensionList;
use Symfony\Component\DependencyInjection\ContainerInterface;

class AutocompleteProfileController extends AutocompleteExtensionController {

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('extension.list.profile'),
    );
  }

  public function __construct(
    protected ProfileExtensionList $profileList,
  ) {
  }

  protected function getExtensions(): iterable {
    return $this->profileList->getList();
  }

}
