<?php

declare(strict_types=1);

namespace Drupal\devel_wizard\Controller;

use Drupal\Core\Extension\ThemeExtensionList;
use Symfony\Component\DependencyInjection\ContainerInterface;

class AutocompleteThemeController extends AutocompleteExtensionController {

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('extension.list.theme'),
    );
  }

  public function __construct(
    protected ThemeExtensionList $themeList,
  ) {
  }

  protected function getExtensions(): iterable {
    return $this->themeList->getList();
  }

}
