<?php

declare(strict_types=1);

namespace Drupal\Tests\devel_wizard\Kernel\Plugin\DevelWizard\Spell;

use Drupal\Tests\devel_wizard\Traits\TemplateTrait;

class RouteAccessCheckerSpellTest extends SpellTestBase {

  use TemplateTrait;

  /**
   * {@inheritdoc}
   */
  public static $modules = [
    'devel_wizard',
  ];

  public function casesTemplateAccessCheckerPhp(): array {
    return $this->collectTemplateCases('spell/route_access_checker/access-checker.php.twig');
  }

  /**
   * @dataProvider casesTemplateAccessCheckerPhp
   *
   * @throws \Exception
   */
  public function testTemplateAccessCheckerPhp(string $expected, string $template, array $context): void {
    /** @var \Drupal\Core\Template\TwigEnvironment $twig */
    $twig = \Drupal::getContainer()->get('twig');
    static::assertSame(
      $expected,
      $twig->render($template, $context),
    );
  }

}
