<?php

declare(strict_types=1);

namespace Drupal\Tests\devel_wizard\Kernel\Templates;

use Drupal\Tests\devel_wizard\Kernel\TestBase as MainTestBase;
use Drupal\Tests\devel_wizard\Traits\TemplateTrait;

abstract class TestBase extends MainTestBase {

  use TemplateTrait;

  protected static string $templateName = '';

  public function casesTemplate(): array {
    return $this->collectTemplateCases(static::$templateName);
  }

  /**
   * @dataProvider casesTemplate
   */
  public function testTemplate(string $expected, array $context) {
    $twig = \Drupal::getContainer()->get('twig');
    $actual = $twig->render(
      '@' . $this->templateNamespace . '/' . static::$templateName . '.twig',
      $context,
    );

    $this->assertSame($expected, $actual);
  }

}
